// C/C++ Headers

#include <iostream.h>

// Local Headers

#include "AndRegionNode.h"

AndRegionNode::AndRegionNode(
   const RegionNode *first, const RegionNode *second
)  :
   mFirst(first),
   mSecond(second)
{
}

AndRegionNode::~AndRegionNode()
{
   delete (RegionNode *)mFirst;
   delete (RegionNode *)mSecond;
}

int AndRegionNode::contains(
   const ComplexNode *point,
   ComplexVariables &cv,
   DoubleVariables  &dv,
   ColorEnvironment &env
)  const
{
   return(
      mFirst->contains(point, cv, dv, env) &&
      mSecond->contains(point, cv, dv, env)
   );
}

ostream &AndRegionNode::print(ostream &out) const
{
   out << "r_and(";
   mFirst->print(out);
   out << ", ";
   mSecond->print(out);
   return(out << ")");
}
