// C/C++ Headers

#include <iostream.h>

// Local Headers

#include "AssignmentDoubleNode.h"
#include "DoubleAssignmentStatement.h"
#include "DoubleVariables.h"

AssignmentDoubleNode::AssignmentDoubleNode(
   const DoubleAssignmentStatement *statement
) :
   mStatement(statement),
   mIsPostAssignment(mStatement->getIsPostAssignment())
{
}

AssignmentDoubleNode::~AssignmentDoubleNode()
{
   delete (DoubleAssignmentStatement *)mStatement;
}

double AssignmentDoubleNode::evaluate(
   ComplexVariables &cv,
   DoubleVariables &dv,
   ColorEnvironment &env
) const
{
   double value = 0.0;

   if(mIsPostAssignment)
      value = dv.get(mStatement->getHandle());

   mStatement->execute(cv, dv, env, NULL, NULL);

   if(!mIsPostAssignment)
      value = dv.get(mStatement->getHandle());

   return(value);
}

ostream &AssignmentDoubleNode::print(ostream &out) const
{
   out << "(";
   mStatement->print(out);
   return(out << ")");
}
