// C/C++ Headers

#include <string.h>
#include <iostream.h>

// Local Headers

#include "ComplexAssignmentStatement.h"
#include "ComplexNode.h"
#include "ComplexVariables.h"
#include "DoubleVariables.h"

ComplexAssignmentStatement::ComplexAssignmentStatement(
   int handle,
   char *name,
   const ComplexNode *ptr,
   int isPostAssignment
) :
   mHandle(handle),
   mPtr(ptr),
   mIsPostAssignment(isPostAssignment)
{
   mName = new char[strlen(name) + 1];
   strcpy(mName, name);
}

ComplexAssignmentStatement::~ComplexAssignmentStatement()
{
   delete [] mName;
   delete (ComplexNode *)mPtr;
}

int ComplexAssignmentStatement::execute(
   ComplexVariables &cv,
   DoubleVariables  &dv,
   ColorEnvironment &env,
   InfiniteLoopCallback *,
   LoopControl *
) const
{
   cv.set(mHandle, mPtr->evaluate(cv, dv, env));
   return(TRUE);
}

int ComplexAssignmentStatement::getIsPostAssignment() const
{
   return(mIsPostAssignment);
}

int ComplexAssignmentStatement::getHandle() const
{
   return(mHandle);
}

ostream &ComplexAssignmentStatement::print(ostream &out) const
{
   out << mName << " = ";
   mPtr->print(out);
   return(out);
}
