#ifndef _COMPLEX_ASSIGNMENT_STATEMENT_H_
#   define _COMPLEX_ASSIGNMENT_STATEMENT_H_

#include "Statement.h"

class ComplexNode;

class ComplexAssignmentStatement : public Statement
{
   public:
      ComplexAssignmentStatement(
         int handle,
         char *name,
         const ComplexNode *ptr,
         int isPostAssignment = FALSE
      );

      ~ComplexAssignmentStatement();

      int execute(
         ComplexVariables &cv,
         DoubleVariables  &dv,
         ColorEnvironment &env,
         InfiniteLoopCallback *callback,
         LoopControl *control
      ) const;

      int getIsPostAssignment() const;
      int getHandle() const;

      ostream &print(ostream &out) const;

   private:
      int mHandle;
      char *mName;
      const ComplexNode *mPtr;
      int mIsPostAssignment;
};
#endif
