// C/C++ Headers

#include <string.h>
#include <iostream.h>
#include <iomanip.h>

// Local Headers

#include "ComplexVariablePrintArg.h"
#include "ComplexVariables.h"

ComplexVariablePrintArg::ComplexVariablePrintArg(
   char *variableName, int handle
)  :
   mVariableName(strcpy(new char[strlen(variableName) + 1], variableName)),
   mHandle(handle)
{
}

ComplexVariablePrintArg::~ComplexVariablePrintArg()
{
   delete [] mVariableName;
}

void ComplexVariablePrintArg::execute(
   ComplexVariables &cv,
   DoubleVariables &,
   ostream &out           
)  const
{
   // Can't just do: out << cv.get(mHandle)
   // since MSVC 6 claims there's no such method :-P

   dcomplex value = cv.get(mHandle);

   out << setprecision(10) <<
      "[" << __REAL(value) << ", " << __IMAG(value) << "]";
}

ostream & ComplexVariablePrintArg::print(ostream &out) const
{
   return(out << mVariableName);
}
