#ifndef _COMPLEX_VARIABLES_H_
#   define _COMPLEX_VARIABLES_H_

#include "dcomplex.h"

class ostream;
struct ComplexEntry;

class ComplexVariables
{
   public:
      ComplexVariables();
      ~ComplexVariables();

      enum { UNDEFINED = -1 };

      int assign(const char *name);
      int lookup(const char *name) const;
      const char *getName(int handle) const;

      void initialize();
      void set(int handle, dcomplex value);
      dcomplex get(int handle) const;

      ostream &print(ostream &out) const;
      static int main(int argc, char **argv);

      static const dcomplex ZERO;

   private:
      ComplexVariables(const ComplexVariables &other);
      ComplexVariables &operator=(const ComplexVariables &other);
      int checkHandle(int handle) const;

      int mCount;
      ComplexEntry **mEntries;
};

ostream &operator<<(ostream &out, const ComplexVariables &cv);

#endif
