#ifndef _DOUBLE_ASSIGNMENT_STATEMENT_H_
#   define _DOUBLE_ASSIGNMENT_STATEMENT_H_

#include "Statement.h"

class DoubleNode;

class DoubleAssignmentStatement : public Statement
{
   public:
      DoubleAssignmentStatement(
         int handle,
         char *name,
         const DoubleNode *ptr,
         int isPostAssignment = FALSE
      );

      ~DoubleAssignmentStatement();

      int execute(
         ComplexVariables &cv,
         DoubleVariables  &dv,
         ColorEnvironment &env,
         InfiniteLoopCallback *callback,
         LoopControl *control
      ) const;

      int getIsPostAssignment() const;
      int getHandle() const;

      ostream &print(ostream &out) const;

   private:
      int mHandle;
      char *mName;
      const DoubleNode *mPtr;
      int mIsPostAssignment;
};
#endif
