#ifndef _HSV_SET_COLOR_STATEMENT_H_
#   define _HSV_SET_COLOR_STATEMENT_H_

class DoubleNode;

#include "Statement.h"

class HSVSetColorStatement : public Statement
{
   public:
      HSVSetColorStatement(
         const DoubleNode *hNode,
         const DoubleNode *sNode,
         const DoubleNode *vNode
      );

      ~HSVSetColorStatement();

      int execute(
         ComplexVariables &cv,
         DoubleVariables  &dv,
         ColorEnvironment &env,
         InfiniteLoopCallback *callback,
         LoopControl *control
      ) const;

      ostream &print(ostream &out) const;

   private:
      const DoubleNode *mH;
      const DoubleNode *mS;
      const DoubleNode *mV;
};

#endif
