// C/C++ Headers

#include <iostream.h>

// Local Headers

#include "IndexedSetColorStatement.h"
#include "DoubleNode.h"
#include "ColorEnvironment.h"

IndexedSetColorStatement::IndexedSetColorStatement(const DoubleNode *node) :
   mNode(node)
{
}

IndexedSetColorStatement::~IndexedSetColorStatement()
{
   delete mNode;
}

int IndexedSetColorStatement::execute(
   ComplexVariables &cv,
   DoubleVariables  &dv,
   ColorEnvironment &env,
   InfiniteLoopCallback *,
   LoopControl *
) const
{
   int red   = 0;
   int green = 0;
   int blue  = 0;

   if(env.getRGB((int)mNode->evaluate(cv, dv, env), &red, &green, &blue))
      env.setRGB(red, green, blue);

   return(TRUE);
}

ostream &IndexedSetColorStatement::print(ostream &out) const
{
   out << "set_color(";
   mNode->print(out);
   out << ")";
   return(out);
}
