// C/C++ Headers

#include <iostream.h>

// Local Headers

#include "NotRegionNode.h"

NotRegionNode::NotRegionNode(const RegionNode *node)
   :
   mNode(node)
{
}

NotRegionNode::~NotRegionNode()
{
   delete (RegionNode *)mNode;
}

int NotRegionNode::contains(
   const ComplexNode *point,
   ComplexVariables &cv,
   DoubleVariables  &dv,
   ColorEnvironment &env
)  const
{
   return(!mNode->contains(point, cv, dv, env));
}

ostream &NotRegionNode::print(ostream &out) const
{
   out << "r_not(";

   mNode->print(out);

   return(out << ")");
}
