#ifndef _RGB_SET_COLOR_STATEMENT_H_
#   define _RGB_SET_COLOR_STATEMENT_H_

class DoubleNode;

#include "Statement.h"

class RGBSetColorStatement : public Statement
{
   public:
      RGBSetColorStatement(
         const DoubleNode *redNode,
         const DoubleNode *greenNode,
         const DoubleNode *blueNode
      );

      ~RGBSetColorStatement();

      int execute(
         ComplexVariables &cv,
         DoubleVariables  &dv,
         ColorEnvironment &env,
         InfiniteLoopCallback *callback,
         LoopControl *control
      ) const;

      ostream &print(ostream &out) const;

   private:
      const DoubleNode *mRed;
      const DoubleNode *mGreen;
      const DoubleNode *mBlue;
};

#endif
