// C/C++ Headers

#include <iostream.h>

#include "TernaryComplexNode.h"
#include "BooleanNode.h"

TernaryComplexNode::TernaryComplexNode(
   const BooleanNode *testPtr,
   const ComplexNode  *firstPtr,
   const ComplexNode  *secondPtr
)  :
   mTestPtr(testPtr),
   mFirstPtr(firstPtr),
   mSecondPtr(secondPtr)
{
}

TernaryComplexNode::~TernaryComplexNode()
{
   delete (BooleanNode *)mTestPtr;
   delete (ComplexNode *)mFirstPtr;
   delete (ComplexNode *)mSecondPtr;
}

dcomplex TernaryComplexNode::evaluate(
   ComplexVariables &cv,
   DoubleVariables &dv,
   ColorEnvironment &env
) const
{
   return(
      mTestPtr->evaluate(cv, dv, env) ?
      mFirstPtr->evaluate(cv, dv, env) :
      mSecondPtr->evaluate(cv, dv, env)
   );
}

ostream &TernaryComplexNode::print(ostream &out) const
{
   out << "(";
   mTestPtr->print(out);
   out << " ? ";
   mFirstPtr->print(out);
   out << " : ";
   mSecondPtr->print(out);
   out << ")";

   return(out);
}
