// C/C++ Headers

#include <iostream.h>

// Local Headers

#include "XorRegionNode.h"

XorRegionNode::XorRegionNode(
   const RegionNode *first, const RegionNode *second
)  :
   mFirst(first),
   mSecond(second)
{
}

XorRegionNode::~XorRegionNode()
{
   delete (RegionNode *)mFirst;
   delete (RegionNode *)mSecond;
}

int XorRegionNode::contains(
   const ComplexNode *point,
   ComplexVariables &cv,
   DoubleVariables  &dv,
   ColorEnvironment &env
)  const
{
   int firstContains  = mFirst->contains(point, cv, dv, env);
   int secondContains = mSecond->contains(point, cv, dv, env);

   return(firstContains != secondContains);
}

ostream &XorRegionNode::print(ostream &out) const
{
   out << "r_xor(";
   mFirst->print(out);
   out << ", ";
   mSecond->print(out);
   return(out << ")");
}
